function psStripReverseProxyURI( aURI )
{
    if( aURI == null ||
    	'string' != ( typeof aURI ) )
    {
	return aURI;
    }

    var lResult = aURI;
    var gatewayURI = '$INSERT_GATEWAY_URI$';
    var index = aURI.toLowerCase().indexOf( gatewayURI.toLowerCase() );
    if( index != -1)
    {
	lResult = (new URIObject( aURI )).normalizedURI.substring( index + gatewayURI.length + 1 );
	var lScheme = 'redirect/';
    	if( lResult.toLowerCase().indexOf( lScheme ) == 0 )
    	{
		lResult = lResult.substring( lScheme.length );
    	}
    }
    return lResult;
}//psStripReverseProxyURI()

function $CONVERT_SYSTEM$( aOBJRef, aSysVar, aValue )
{
   if( (aSysVar == null) ||
	'string' != ( typeof aSysVar ) ||
	(psTrim( aSysVar ).length == 0) )
    {
	return aValue;
    }

    //document.URL, window.location or Just location
    if( psEndsWith( aSysVar, ".URL" ) ||
        psEndsWith( aSysVar, ".location" ) ||
        psEquals( aSysVar, 'location' ) )
    {
    	return psStripReverseProxyURI( aValue );
    }

    if( aOBJRef == null )
    {
       return aValue;
    }

    //domain name is same as location hostname
    if( psEndsWith( aSysVar, ".domain" ) &&
    	'document' != (typeof aOBJRef  ) )
    {
    	aOBJRef = aOBJRef.location;
  //  	aSysVar = ".hostname";
    }

    //do nothing object ID is not location object
    //if(	'location' != (typeof aOBJRef ) )
    //{
    // 	return aValue;
    //}

    var lStdVarArray =
    	[".href", ".protocol", ".hostname", ".host", ".port", ".pathname", ".hash", ".search"];

    //handling of location properties
    for( i = 0; i < lStdVarArray.length; i++ )
    {
	if( psEndsWith( aSysVar, lStdVarArray[i] ) )
	{
	    var inranetURI = psStripReverseProxyURI( aOBJRef.href );
	    if( aOBJRef.href.indexOf( inranetURI ) != -1 )
	    {
		var lCustomURIObject = new CustomLocation( inranetURI );
		if( lCustomURIObject != null )
		{
		    var bResult = eval( "lCustomURIObject" + lStdVarArray[i] );
		    if( bResult != null )
		    {
			return bResult;
		    }
		}
	    }
	}
    }

    return aValue;
}//$CONVERT_SYSTEM$()
